/*
Copyright Renaud GICQUEL 2005-2008  
renaud.gicquel@ensmp.fr

Ce logiciel est un programme informatique servant  modliser des systmes nergtiques.   

Ce logiciel est rgi par la licence CeCILL soumise au droit franais et respectant les principes de diffusion des logiciels libres. Vous pouvez utiliser, modifier et/ou redistribuer ce programme sous les conditions de la licence CeCILL telle que diffuse par le CEA, le CNRS et l'INRIA  sur le site "http://www.cecill.info".  

En contrepartie de l'accessibilit au code source et des droits de copie, de modification et de redistribution accords par cette licence, il n'est offert aux utilisateurs qu'une garantie limite.  Pour les mmes raisons, seule une responsabilit restreinte pse sur l'auteur du programme,  le titulaire des droits patrimoniaux et les concdants successifs.  

A cet gard  l'attention de l'utilisateur est attire sur les risques associs au chargement,   l'utilisation,   la modification et/ou au dveloppement et  la reproduction du logiciel par l'utilisateur tant  donn sa spcificit de logiciel libre, qui peut le rendre complexe   manipuler et qui le rserve donc  des dveloppeurs et des professionnels avertis possdant  des  connaissances  informatiques approfondies.  Les utilisateurs sont donc invits  charger  et  tester  l'adquation  du logiciel  leurs besoins dans des conditions permettant d'assurer la scurit de leurs systmes et ou de leurs donnes et, plus gnralement,   l'utiliser et l'exploiter dans les mmes conditions de scurit.   

Le fait que vous puissiez accder  cet en-tte signifie que vous avez  pris connaissance de la licence CeCILL, et que vous en avez accept les termes. 

This software is a computer program whose purpose is to model energy systems.  

This software is governed by the CeCILL  license under French law and abiding by the rules of distribution of free software.  You can  use,  modify and/ or redistribute the software under the terms of the CeCILL license as circulated by CEA, CNRS and INRIA at the following URL "http://www.cecill.info".   

As a counterpart to the access to the source code and  rights to copy, modify and redistribute granted by the license, users are provided only with a limited warranty  and the software's author,  the holder of the economic rights,  and the successive licensors  have only  limited liability.   

In this respect, the user's attention is drawn to the risks associated with loading,  using,  modifying and/or developing or reproducing the software by the user in light of its specific status of free software, that may mean  that it is complicated to manipulate,  and  that  also therefore means  that it is reserved for developers  and  experienced professionals having in-depth computer knowledge. Users are therefore encouraged to load and test the software's suitability as regards their requirements in conditions enabling the security of their systems and/or  data to be ensured and,  more generally, to use and operate it in the  same conditions as regards security.   

The fact that you are presently reading this means that you have had knowledge of the CeCILL license and that you accept its terms.  
*/

package extThopt;

import javax.swing.*;
import java.awt.*;
import java.util.*;
import rg.corps.*;

/**
 * Classe pour calculer un cycle  vapeur en rgime non-nominal
 * 
 * le modle de turbine est celui de Stodola
 *
 * @author Renaud GICQUEL
 */
public class TSGSteamPlantDriver extends ExtPilot implements Inversable
{
	boolean isInitialized=false;
	boolean isBuilt=false;
	String[]component,componentName,nozzleName;
    String turbineName="",boilerName,condenserName, boilerSettings="", condSettings="";
    
    TechnoHx technoBoiler, technoCond;
    TechnoTurb technoTurbine;
    double DeltaHcond,Te,Tf,massFlow, DTsurch, DTssrefr, Aboiler, Acond, AboilerReel, AcondReel, Uboiler, Ucond;
    double tauTurb, DeltaHboiler, mCpmin, mCpmax, NUT,R,epsilon, AdesignBoiler, AdesignCond, lambdaVol;
    
    double TamontCompr, PamontCompr, UAboiler, UAcond,DeltaH0,T2,Tboiler, Pboiler,Vboiler,Hboiler,DeltaH_NH3, Twater,
    rotationSpeed, Pcond, mCpBoilerSteam, mCpRefrigCond, mCpBoilerTransfFluid, mCpCalopCond, Tcond;
    
	double a0_value=0.96, alpha_value=0.038, Kh=872.7969721981, Vs_value=0.0199, Tsuperheating, gasFlow, eta_is;	
    
    PointThopt boilerUpstream, boilerDownstream, condUptream, condDownstream, hotGases, inRiver, coldGases, outRiver;
    
	String tab=new String("\t");
	String ligne=new String("\n");
    
    Corps subst;
     

	public TSGSteamPlantDriver()
	{
		//{{INIT_CONTROLS
		setTitle("Steam power plant driver");
		getContentPane().setLayout(null);
		setSize(640,590);
		setVisible(false);
		bInitialSettings.setText("Initial settings");
		bInitialSettings.setActionCommand("load");
		getContentPane().add(bInitialSettings);
		bInitialSettings.setBounds(420,12,156,36);
		JLabel6.setText("high pressure");
		getContentPane().add(JLabel6);
		JLabel6.setForeground(new java.awt.Color(102,102,153));
		JLabel6.setBounds(312,192,156,24);
		getContentPane().add(Pboiler_value);
		Pboiler_value.setBounds(480,192,96,24);
		Pboiler_value.setSelectionColor(new java.awt.Color(204,204,255));
		Pboiler_value.setSelectedTextColor(java.awt.Color.black);
		Pboiler_value.setCaretColor(java.awt.Color.black);
		Pboiler_value.setDisabledTextColor(new java.awt.Color(153,153,153));
		JLabel4.setText("low pressure");
		getContentPane().add(JLabel4);
		JLabel4.setForeground(java.awt.Color.red);
		JLabel4.setBounds(12,360,156,24);
		Pcond_value.setSelectionColor(new java.awt.Color(204,204,255));
		Pcond_value.setSelectedTextColor(java.awt.Color.black);
		Pcond_value.setCaretColor(java.awt.Color.black);
		Pcond_value.setDisabledTextColor(new java.awt.Color(153,153,153));
		Pcond_value.setEditable(false);
		getContentPane().add(Pcond_value);
		Pcond_value.setBounds(180,360,120,24);
		AdesignCond_value.setSelectionColor(new java.awt.Color(204,204,255));
		AdesignCond_value.setSelectedTextColor(java.awt.Color.black);
		AdesignCond_value.setCaretColor(java.awt.Color.black);
		AdesignCond_value.setDisabledTextColor(new java.awt.Color(153,153,153));
		getContentPane().add(AdesignCond_value);
		AdesignCond_value.setBounds(480,96,100,24);
		JLabel5.setText("set condenser area");
		getContentPane().add(JLabel5);
		JLabel5.setForeground(new java.awt.Color(102,102,153));
		JLabel5.setBounds(312,96,156,24);
		bCalculate.setText("Calculate ");
		bCalculate.setActionCommand("Calculate ");
		getContentPane().add(bCalculate);
		bCalculate.setBounds(432,324,156,60);
		JLabel10.setText("Design settings");
		getContentPane().add(JLabel10);
		JLabel10.setForeground(java.awt.Color.blue);
		JLabel10.setFont(new Font("Dialog", Font.BOLD, 18));
		JLabel10.setBounds(12,12,553,25);
		UAcond_value.setSelectionColor(new java.awt.Color(204,204,255));
		UAcond_value.setSelectedTextColor(java.awt.Color.black);
		UAcond_value.setCaretColor(java.awt.Color.black);
		UAcond_value.setDisabledTextColor(new java.awt.Color(153,153,153));
		getContentPane().add(UAcond_value);
		UAcond_value.setBounds(480,60,100,24);
		JLabel12.setText("condenser UA");
		getContentPane().add(JLabel12);
		JLabel12.setBounds(312,60,156,24);
		JLabel13.setText("set boiler area");
		getContentPane().add(JLabel13);
		JLabel13.setForeground(new java.awt.Color(102,102,153));
		JLabel13.setBounds(12,96,161,22);
		AdesignBoiler_value.setSelectionColor(new java.awt.Color(204,204,255));
		AdesignBoiler_value.setSelectedTextColor(java.awt.Color.black);
		AdesignBoiler_value.setCaretColor(java.awt.Color.black);
		AdesignBoiler_value.setDisabledTextColor(new java.awt.Color(153,153,153));
		getContentPane().add(AdesignBoiler_value);
		AdesignBoiler_value.setBounds(180,96,100,24);
		JLabel14.setText("Stodola constant");
		getContentPane().add(JLabel14);
		JLabel14.setBounds(12,192,150,23);
		Kh_value.setSelectionColor(new java.awt.Color(204,204,255));
		Kh_value.setSelectedTextColor(java.awt.Color.black);
		Kh_value.setCaretColor(java.awt.Color.black);
		Kh_value.setDisabledTextColor(new java.awt.Color(153,153,153));
		getContentPane().add(Kh_value);
		Kh_value.setBounds(180,192,100,24);
		JLabel16.setText("DeltaH boiler");
		getContentPane().add(JLabel16);
		JLabel16.setForeground(java.awt.Color.red);
		JLabel16.setBounds(324,396,144,24);
		DeltaHboiler_value.setSelectionColor(new java.awt.Color(204,204,255));
		DeltaHboiler_value.setSelectedTextColor(java.awt.Color.black);
		DeltaHboiler_value.setCaretColor(java.awt.Color.black);
		DeltaHboiler_value.setDisabledTextColor(new java.awt.Color(153,153,153));
		DeltaHboiler_value.setEditable(false);
		getContentPane().add(DeltaHboiler_value);
		DeltaHboiler_value.setBounds(492,396,120,24);
		JLabel15.setText("boiler UA");
		getContentPane().add(JLabel15);
		JLabel15.setBounds(12,60,156,24);
		UAboiler_value.setSelectionColor(new java.awt.Color(204,204,255));
		UAboiler_value.setSelectedTextColor(java.awt.Color.black);
		UAboiler_value.setCaretColor(java.awt.Color.black);
		UAboiler_value.setDisabledTextColor(new java.awt.Color(153,153,153));
		getContentPane().add(UAboiler_value);
		UAboiler_value.setBounds(180,60,100,24);
		JLabel1.setText("flow rate");
		getContentPane().add(JLabel1);
		JLabel1.setForeground(java.awt.Color.red);
		JLabel1.setBounds(12,468,156,24);
		massFlow_value.setSelectionColor(new java.awt.Color(204,204,255));
		massFlow_value.setSelectedTextColor(java.awt.Color.black);
		massFlow_value.setCaretColor(java.awt.Color.black);
		massFlow_value.setDisabledTextColor(new java.awt.Color(153,153,153));
		massFlow_value.setEditable(false);
		getContentPane().add(massFlow_value);
		massFlow_value.setBounds(180,468,120,24);
		JLabel2.setText("water temperature (C)");
		getContentPane().add(JLabel2);
		JLabel2.setBounds(12,228,156,24);
		Teau_value.setText("5");
		Teau_value.setSelectionColor(new java.awt.Color(204,204,255));
		Teau_value.setSelectedTextColor(java.awt.Color.black);
		Teau_value.setCaretColor(java.awt.Color.black);
		Teau_value.setDisabledTextColor(new java.awt.Color(153,153,153));
		getContentPane().add(Teau_value);
		Teau_value.setBounds(180,228,100,24);
		JLabel3.setText("turbine power");
		getContentPane().add(JLabel3);
		JLabel3.setForeground(java.awt.Color.red);
		JLabel3.setBounds(324,432,156,24);
		tauCompr_value.setSelectionColor(new java.awt.Color(204,204,255));
		tauCompr_value.setSelectedTextColor(java.awt.Color.black);
		tauCompr_value.setCaretColor(java.awt.Color.black);
		tauCompr_value.setDisabledTextColor(new java.awt.Color(153,153,153));
		tauCompr_value.setEditable(false);
		getContentPane().add(tauCompr_value);
		tauCompr_value.setBounds(492,432,120,24);
		JLabel7.setText("DeltaH cond");
		getContentPane().add(JLabel7);
		JLabel7.setForeground(java.awt.Color.red);
		JLabel7.setBounds(12,432,156,24);
		DeltaHcond_value.setSelectionColor(new java.awt.Color(204,204,255));
		DeltaHcond_value.setSelectedTextColor(java.awt.Color.black);
		DeltaHcond_value.setCaretColor(java.awt.Color.black);
		DeltaHcond_value.setDisabledTextColor(new java.awt.Color(153,153,153));
		DeltaHcond_value.setEditable(false);
		getContentPane().add(DeltaHcond_value);
		DeltaHcond_value.setBounds(180,432,120,24);
		JLabel8.setText("Simulation results");
		getContentPane().add(JLabel8);
		JLabel8.setForeground(java.awt.Color.red);
		JLabel8.setFont(new Font("Dialog", Font.BOLD, 18));
		JLabel8.setBounds(12,324,553,25);
		JLabel9.setText("calculated boiler area");
		getContentPane().add(JLabel9);
		JLabel9.setBounds(12,132,156,24);
		AcalculatedBoiler_value.setSelectionColor(new java.awt.Color(204,204,255));
		AcalculatedBoiler_value.setSelectedTextColor(java.awt.Color.black);
		AcalculatedBoiler_value.setCaretColor(java.awt.Color.black);
		AcalculatedBoiler_value.setDisabledTextColor(new java.awt.Color(153,153,153));
		AcalculatedBoiler_value.setEditable(false);
		getContentPane().add(AcalculatedBoiler_value);
		AcalculatedBoiler_value.setBounds(180,132,100,24);
		JLabel11.setText("calculated condenser area");
		getContentPane().add(JLabel11);
		JLabel11.setBounds(312,132,156,24);
		AcalculatedCond_value.setSelectionColor(new java.awt.Color(204,204,255));
		AcalculatedCond_value.setSelectedTextColor(java.awt.Color.black);
		AcalculatedCond_value.setCaretColor(java.awt.Color.black);
		AcalculatedCond_value.setDisabledTextColor(new java.awt.Color(153,153,153));
		AcalculatedCond_value.setEditable(false);
		getContentPane().add(AcalculatedCond_value);
		AcalculatedCond_value.setBounds(480,132,100,24);
		JLabel17.setText("Efficiency");
		getContentPane().add(JLabel17);
		JLabel17.setForeground(java.awt.Color.red);
		JLabel17.setBounds(324,468,156,24);
		eff_value.setSelectionColor(new java.awt.Color(204,204,255));
		eff_value.setSelectedTextColor(java.awt.Color.black);
		eff_value.setCaretColor(java.awt.Color.black);
		eff_value.setDisabledTextColor(new java.awt.Color(153,153,153));
		eff_value.setEditable(false);
		getContentPane().add(eff_value);
		eff_value.setBounds(492,468,120,24);
		JLabel20.setText("max temperature (C)");
		getContentPane().add(JLabel20);
		JLabel20.setBounds(312,228,156,24);
		Tmax_value.setText("560");
		Tmax_value.setSelectionColor(new java.awt.Color(204,204,255));
		Tmax_value.setSelectedTextColor(java.awt.Color.black);
		Tmax_value.setCaretColor(java.awt.Color.black);
		Tmax_value.setDisabledTextColor(new java.awt.Color(153,153,153));
		getContentPane().add(Tmax_value);
		Tmax_value.setBounds(480,228,100,24);
		//}}

		//{{REGISTER_LISTENERS
		SymWindow aSymWindow = new SymWindow();
		this.addWindowListener(aSymWindow);
		SymAction lSymAction = new SymAction();
		bInitialSettings.addActionListener(lSymAction);
		bCalculate.addActionListener(lSymAction);
		//}}

		//{{INIT_MENUS
		//}}

		type="TSG steam plant driver";
	}

    /**
    * returns the component type 
    **/
    public String getCompType(){
        return type;
    }
    
	public String getClassDescription(){
	    return "driver for a steam cycle\n\n\nauthor : R. Gicquel march 2011";
	}
    
    void setupProject(){
        //on rcupre ici les instances des transfos externes dont on a besoin
        //afin d'accder  leurs diffrents paramtres pour les calculs ultrieurs
        
  }
	
	public void setVisible(boolean b)
	{
		if(b)
		{
			setLocation(50, 50);
		}
	super.setVisible(b);
	}

	public void addNotify()
	{
		// Record the size of the window prior to calling parents addNotify.
		Dimension d = getSize();

		super.addNotify();

		if (fComponentsAdjusted)
			return;

		// Adjust components according to the insets
		Insets ins = getInsets();
		setSize(ins.left + ins.right + d.width, ins.top + ins.bottom + d.height);
		Component components[] = getContentPane().getComponents();
		for (int i = 0; i < components.length; i++)
			{
			Point p = components[i].getLocation();
			p.translate(ins.left, ins.top);
			components[i].setLocation(p);
		}
		fComponentsAdjusted = true;
	}

	// Used for addNotify check.
	boolean fComponentsAdjusted = false;

	class SymWindow extends java.awt.event.WindowAdapter
	{
		public void windowClosing(java.awt.event.WindowEvent event)
		{
		Object object = event.getSource();
		if (object == TSGSteamPlantDriver.this)
			Thrust_WindowClosing(event);
		}
	}

	void Thrust_WindowClosing(java.awt.event.WindowEvent event)
	{
		dispose();		 // dispose of the Frame.
	}
	//{{DECLARE_CONTROLS
	javax.swing.JButton bInitialSettings = new javax.swing.JButton();
	javax.swing.JLabel JLabel6 = new javax.swing.JLabel();
	javax.swing.JTextField Pboiler_value = new javax.swing.JTextField();
	javax.swing.JLabel JLabel4 = new javax.swing.JLabel();
	javax.swing.JTextField Pcond_value = new javax.swing.JTextField();
	javax.swing.JTextField AdesignCond_value = new javax.swing.JTextField();
	javax.swing.JLabel JLabel5 = new javax.swing.JLabel();
	javax.swing.JButton bCalculate = new javax.swing.JButton();
	javax.swing.JLabel JLabel10 = new javax.swing.JLabel();
	javax.swing.JTextField UAcond_value = new javax.swing.JTextField();
	javax.swing.JLabel JLabel12 = new javax.swing.JLabel();
	javax.swing.JLabel JLabel13 = new javax.swing.JLabel();
	javax.swing.JTextField AdesignBoiler_value = new javax.swing.JTextField();
	javax.swing.JLabel JLabel14 = new javax.swing.JLabel();
	javax.swing.JTextField Kh_value = new javax.swing.JTextField();
	javax.swing.JLabel JLabel16 = new javax.swing.JLabel();
	javax.swing.JTextField DeltaHboiler_value = new javax.swing.JTextField();
	javax.swing.JLabel JLabel15 = new javax.swing.JLabel();
	javax.swing.JTextField UAboiler_value = new javax.swing.JTextField();
	javax.swing.JLabel JLabel1 = new javax.swing.JLabel();
	javax.swing.JTextField massFlow_value = new javax.swing.JTextField();
	javax.swing.JLabel JLabel2 = new javax.swing.JLabel();
	javax.swing.JTextField Teau_value = new javax.swing.JTextField();
	javax.swing.JLabel JLabel3 = new javax.swing.JLabel();
	javax.swing.JTextField tauCompr_value = new javax.swing.JTextField();
	javax.swing.JLabel JLabel7 = new javax.swing.JLabel();
	javax.swing.JTextField DeltaHcond_value = new javax.swing.JTextField();
	javax.swing.JLabel JLabel8 = new javax.swing.JLabel();
	javax.swing.JLabel JLabel9 = new javax.swing.JLabel();
	javax.swing.JTextField AcalculatedBoiler_value = new javax.swing.JTextField();
	javax.swing.JLabel JLabel11 = new javax.swing.JLabel();
	javax.swing.JTextField AcalculatedCond_value = new javax.swing.JTextField();
	javax.swing.JLabel JLabel17 = new javax.swing.JLabel();
	javax.swing.JTextField eff_value = new javax.swing.JTextField();
	javax.swing.JLabel JLabel20 = new javax.swing.JLabel();
	javax.swing.JTextField Tmax_value = new javax.swing.JTextField();
	//}}

	//{{DECLARE_MENUS
	//}}


	class SymAction implements java.awt.event.ActionListener
	{
		public void actionPerformed(java.awt.event.ActionEvent event)
		{
			Object object = event.getSource();
			if (object == bInitialSettings)
				bInitialSettings_actionPerformed(event);
			else if (object == bCalculate)
				bCalculate_actionPerformed(event);
			
		}
	}

	public void init(){
		isInitialized=true;
		proj=getProjet();
		setupProject();
		//On rcupre la liste et le type des composants prsents dans l'diteur de schmas
		String[]listComp=proj.getEditorComponentList();
		component=new String[listComp.length];
		componentName=new String[listComp.length];
		
		//on en extrait les noms des transfos du noyau dont on a besoin
		// savoir le compresseur et la chambre de combustion
        for(int i=0;i<listComp.length;i++){
		    component[i]=Util.extr_value(listComp[i], "type");
		    componentName[i]=Util.extr_value(listComp[i], "name");
		    if(component[i].equals("Compression"))turbineName=componentName[i];
		    if(component[i].equals("Expansion"))turbineName=componentName[i];
            System.out.println(component[i]+"\t"+componentName[i]);
            System.out.println(listComp[i]);
            System.out.println();
        }
        
        String[]listHX=proj.getHxList ();//ensuite, il faut utiliser getProperties
        for(int i=0;i<listHX.length;i++){
            System.out.println(listHX[i]);
            System.out.println();
        }
        //test de cohrence (des messages d'erreur plus prcis seraient souhaitables)
        if((!turbineName.equals(""))&& isBuilt)isBuilt=true;
		if(isBuilt)show();//on n'ouvre le pilote que si sa structure est correcte
		
        //initializations for simulation 
        boilerUpstream=new PointThopt(proj,"2");
        boilerDownstream=new PointThopt(proj,"3b");
        condUptream=new PointThopt(proj,"4");
        condDownstream=new PointThopt(proj,"1");
        hotGases=new PointThopt(proj,"hot gas");
        coldGases=new PointThopt(proj,"cooled gas");
        inRiver=new PointThopt(proj,"river inlet");
        outRiver=new PointThopt(proj,"river outlet");
        condDownstream.getProperties();
        subst=(rg.corps.Corps)condDownstream.lecorps;  
        
	    boilerName="boiler";
	    condenserName="condenser";
	    turbineName="turbine";
        
		technoBoiler=new TechnoSteamGenerator(proj, boilerName, hotGases, coldGases, boilerUpstream, boilerDownstream);
	    addTechnoVector(technoBoiler);
		technoCond=new TechnoCondensor(proj, condenserName, condUptream, condDownstream, inRiver, outRiver);
	    addTechnoVector(technoCond);
	
	    technoTurbine= new TechnoTurb(proj, turbineName, boilerDownstream, condUptream);
	    addTechnoVector(technoTurbine);
		setupTechnoDesigns(vTechno);
	}
	
	void bInitialSettings_actionPerformed(java.awt.event.ActionEvent event){
	    if(!isInitialized)init();//la premire fois, on initialise, car il faut un constructeur sans argument
	                            //pour instancier la classe par le RMI
	                            
        String[] args=new String[2];
        args[0]="project";
        args[1]="";
        Vector vProp=proj.getProperties(args);
        String flowUnit=(String)vProp.elementAt(0);
        if(!flowUnit.equals("kg/s")){
	        String msg = "Watch out! the flow rate unit should be\"kg/s\".\nYou may have discrepancies between your units \nand those used for heat exchanger design";
	        JOptionPane.showMessageDialog(this, msg);  
        }
        
	    if(!boilerName.equals("")){//boiler initialization
            args=new String[2];
            args[0]="heatEx";
            args[1]=boilerName;
            vProp=proj.getProperties(args);
            Double f=(Double)vProp.elementAt(15);
            UAboiler=f.doubleValue();
            String fluideChaud=(String)vProp.elementAt(0);            
            args[0]="process";
            args[1]=fluideChaud;
            vProp=proj.getProperties(args);
            f=(Double)vProp.elementAt(4);
            double DeltaH=-f.doubleValue();
            f=(Double)vProp.elementAt(3);
            gasFlow=f.doubleValue();
            
            boilerUpstream.getProperties();
            boilerDownstream.getProperties();
            DTsurch=boilerDownstream.DTsat;
            hotGases.getProperties();
            coldGases.getProperties();
	        Tf=hotGases.T;

            mCpBoilerTransfFluid=DeltaH/(hotGases.T-coldGases.T);
            mCpBoilerSteam=DeltaH/(boilerDownstream.T-boilerUpstream.T);
            DeltaHboiler=DeltaH;
            UAboiler_value.setText(Util.aff_d(UAboiler,4));
            Tmax_value.setText(Util.aff_d(boilerDownstream.T-273.15,4));
            Pboiler_value.setText(Util.aff_d(boilerDownstream.P,4));
	        
	        //TechnoDesign initializations 
	        technoBoiler.makeDesign();
	        AboilerReel=Util.lit_d(technoBoiler.ADesign_value.getText());
	        //Uboiler will be used later to update UAboiler
	        Uboiler=technoBoiler.UA/AboilerReel;
	        AcalculatedBoiler_value.setText(technoBoiler.ADesign_value.getText());
	    }
	    
	    if(!condenserName.equals("")){//Condenseur initialization  
            args=new String[2];
            args[0]="heatEx";
            args[1]=condenserName;
            vProp=proj.getProperties(args);
            Double f=(Double)vProp.elementAt(15);
            UAcond=f.doubleValue();
            String fluideFroid=(String)vProp.elementAt(1);
            args[0]="process";
            args[1]=fluideFroid;
            vProp=proj.getProperties(args);
            f=(Double)vProp.elementAt(4);
            double DeltaH=f.doubleValue();
            
            condDownstream.getProperties();
            condUptream.getProperties();
	        DTssrefr=condDownstream.DTsat;
            inRiver.getProperties();            
            outRiver.getProperties();            
            Twater=inRiver.T;
	        Teau_value.setText(Util.aff_d(Twater-273.15,4));
	        
            mCpCalopCond=DeltaH/(outRiver.T-inRiver.T);
            mCpRefrigCond=DeltaH/(condUptream.T-condDownstream.T);
            UAcond_value.setText(Util.aff_d(UAcond,4));

	        //initialisations du TechnoDesign
	        technoCond.makeDesign();
	        AcondReel=Util.lit_d(technoCond.ADesign_value.getText());
	        //Ucond sera utilis ultrieurement pour actualiser UAcond
	        Ucond=technoCond.UA/AcondReel;
	        AcalculatedCond_value.setText(technoCond.ADesign_value.getText());
	    }
	    
	    if(!turbineName.equals("")){//turbine initialization 
            args=new String[2];
            args[0]="process";
            args[1]=turbineName;
            vProp=proj.getProperties(args);
            String amont=(String)vProp.elementAt(1);
            String aval=(String)vProp.elementAt(2);
            Double f=(Double)vProp.elementAt(3);
            massFlow=f.doubleValue();
            f=(Double)vProp.elementAt(11);
            eta_is=f.doubleValue();
            
            Kh=technoTurbine.getStodolaConstant();
            Kh_value.setText(Util.aff_d(Kh,4));
	    }
	}
	
	void bCalculate_actionPerformed(java.awt.event.ActionEvent event){
	    if(!isInitialized)init();//first time initialization
	    
	    AdesignBoiler=Util.lit_d(AdesignBoiler_value.getText());
	    AdesignCond=Util.lit_d(AdesignCond_value.getText());
	    Kh=Util.lit_d(Kh_value.getText());
	    UAboiler=Util.lit_d(UAboiler_value.getText());
	    UAcond=Util.lit_d(UAcond_value.getText());

	    Pboiler=Util.lit_d(Pboiler_value.getText());
        boilerDownstream.P=Pboiler;
        boilerDownstream.T=Util.lit_d(Tmax_value.getText())+273.15;
        boilerDownstream.update(UPDATE_T,UPDATE_P,!UPDATE_X);
        boilerDownstream.getProperties();
        
        boilerUpstream.P=Pboiler;
        boilerUpstream.update(!UPDATE_T,UPDATE_P,!UPDATE_X);
        boilerUpstream.getProperties();

	    Twater=Util.lit_d(Teau_value.getText())+273.15;
        inRiver.T=Twater;
        inRiver.update(UPDATE_T,!UPDATE_P,!UPDATE_X);
        inRiver.getProperties();
        
        condUptream.getProperties();
        condDownstream.getProperties();
        DTsurch=boilerDownstream.DTsat;
	    DTssrefr=condDownstream.DTsat;
        
	    //recalculation of the steam flow rate 
        massFlow=technoTurbine.getMassFlow();

	    //search for condensation pressure
        double min=0.008;
        double max=0.7;
        double r_compr=Util.dicho_T (this,0,1, "calculateSteamBalance",min, max,0.01);
                
        if(r_compr<=0){
            String msg="No solution found";
            JOptionPane.showMessageDialog(this, msg);  
        }
        else{
	        for(int j=0;j<3;j++)proj.calcThopt();
            updateHx(boilerName, RECALCULATE, !UPDATE_UA, 0, !UPDATE_EPSI, 0, !UPDATE_DTMIN, 0);
            updateHx(condenserName, RECALCULATE, !UPDATE_UA, 0, !UPDATE_EPSI, 0, !UPDATE_DTMIN, 0);
            updateHx(boilerName, RECALCULATE, !UPDATE_UA, 0, !UPDATE_EPSI, 0, !UPDATE_DTMIN, 0);
            updateHx(condenserName, RECALCULATE, !UPDATE_UA, 0, !UPDATE_EPSI, 0, !UPDATE_DTMIN, 0);
            updateHx(boilerName, RECALCULATE, !UPDATE_UA, 0, !UPDATE_EPSI, 0, !UPDATE_DTMIN, 0);
            updateHx(condenserName, RECALCULATE, !UPDATE_UA, 0, !UPDATE_EPSI, 0, !UPDATE_DTMIN, 0);
	        for(int j=0;j<3;j++)proj.calcThopt();
                    
            eff_value.setText(Util.aff_d(-tauTurb/DeltaHboiler,4));
            DeltaHboiler_value.setText(Util.aff_d(DeltaHboiler,4));
            massFlow_value.setText(Util.aff_d(massFlow,4));
            DeltaHcond_value.setText(Util.aff_d(DeltaHcond,4));
            Pboiler_value.setText(Util.aff_d(Pboiler,4));
            Pcond_value.setText(Util.aff_d(condDownstream.P,4));
            tauCompr_value.setText(Util.aff_d(tauTurb,4));
                    
            boilerUpstream.getProperties();
            boilerDownstream.getProperties();
            condUptream.getProperties();
            condDownstream.getProperties();
            hotGases.getProperties();
            coldGases.getProperties();
            inRiver.getProperties();            
            outRiver.getProperties();            
                    
	        technoBoiler.makeDesign();	            
 	        AcalculatedBoiler_value.setText(technoBoiler.ADesign_value.getText());

	        technoCond.makeDesign();
	        AcalculatedCond_value.setText(technoCond.ADesign_value.getText());
                    
            System.out.println("Twater \tDeltaH boiler \tdbit eau \tDeltaH cond \tP boiler \tP cond \tpuissance NH3 \tPuiss compression");
            System.out.println(Twater+"\t"+DeltaHboiler+"\t"+massFlow+"\t"+DeltaHcond
            +"\t"+Pboiler+"\t"+condDownstream.P+"\t"+tauTurb+"\t"+tauTurb);
	    }
	}
	
	public double f_dicho(double X, double T,String fonc){
        
        if (fonc.equals("calculateSteamBalance"))return calculateSteamBalance(X);
        return 0;
    }
    
    double calculateSteamBalance(double Pc){
        Vector vProp;
        Double f;
        //initial flow rate recalculation
        condUptream.P=Pc;
        condUptream.update(!UPDATE_T,UPDATE_P,!UPDATE_X);
        condUptream.getProperties();

        Pcond=Pc;
        Tcond=subst.getSatTemperature(Pcond, 1);//condensation temperature  
        condDownstream.T=Tcond+DTssrefr; 
        condDownstream.P=Pcond;
        condDownstream.update(UPDATE_T,UPDATE_P,!UPDATE_X);
        condDownstream.getProperties();
        double Hl=condDownstream.H;
        Hl=Hl+condDownstream.V*(boilerDownstream.P-condDownstream.P);//feedwater compression
        
        double z=(boilerDownstream.P*boilerDownstream.P-condUptream.P*condUptream.P)/boilerDownstream.T;
        massFlow=Kh*Math.pow(z, 0.5);//Stodola cone rule
            
        double[]res=Util.epsi_NUT(mCpBoilerSteam,mCpBoilerTransfFluid,UAboiler);
        epsilon=res[0];
        mCpmin=res[1];
        Tf=boilerUpstream.T+DeltaHboiler/epsilon/mCpmin;
            
        hotGases.T=Tf;
        hotGases.update(UPDATE_T,!UPDATE_P,!UPDATE_X);
        coldGases.T=Tf-DeltaHboiler/gasFlow;
        coldGases.update(UPDATE_T,!UPDATE_P,!UPDATE_X);
            
        hotGases.getProperties();
        coldGases.getProperties();

        Pboiler=boilerDownstream.P;//evaporation pressure
        //new DeltaHboiler
        DeltaHboiler=massFlow*(boilerDownstream.H-Hl);
        mCpBoilerSteam=DeltaHboiler/(boilerDownstream.T-condDownstream.T);
        double x=0;

        //turbine recalculation 
        double eta_is=technoTurbine.getRisentr();
        updateprocess(turbineName, "Expansion",RECALCULATE,IS_SET_FLOW, UPDATE_FLOW, massFlow,  UPDATE_ETA, eta_is);
 
        //which provides the power output
        String[] args=new String[2];
        args[0]="process";
        args[1]=turbineName;
        vProp=proj.getProperties(args);
        f=(Double)vProp.elementAt(4);
        tauTurb=f.doubleValue();
        double tauIs=tauTurb/eta_is;
        double PVR=0;

        if(technoTurbine.isPVR()){//if we take into account residual velocity losses 
            condUptream.getProperties();
            double v=condUptream.V;
            double volFlow=massFlow*v;
            PVR=technoTurbine.getPVR(volFlow);
            tauTurb=tauTurb+PVR*massFlow;
            eta_is=tauTurb/tauIs;
            if(eta_is<0.2)eta_is=0.2;//to avoid possible negative values 
            technoTurbine.risentr_value.setText(Util.aff_d(eta_is,4));
            updateprocess(turbineName, "Expansion",RECALCULATE,IS_SET_FLOW, UPDATE_FLOW, massFlow,  UPDATE_ETA, eta_is);
        }
        technoTurbine.getWetIsentrEfficiency(eta_is);
        
        //search of Tcond set by the condenser
        DeltaHcond=DeltaHboiler+tauTurb;
        condUptream.getProperties();
        
        double Tout_refrig=0;
        mCpRefrigCond=DeltaHcond/(condUptream.T-(Tcond+DTssrefr));
        res=Util.epsi_NUT(mCpRefrigCond,mCpCalopCond,UAcond);
        epsilon=res[0];
        mCpmin=res[1];
        double Tentree_refrig=Twater+DeltaHcond/epsilon/mCpmin;
        Tout_refrig=Tentree_refrig-DeltaHcond/mCpRefrigCond;
 
        //the residual is the difference between the two condensation temperatures  
        double diff=Tcond-(Tout_refrig-DTssrefr);
        return diff;
    }
    
    double getWetIsentrEfficiency(PointThopt amont, PointThopt aval, double eta_is_sec){
        aval.getProperties();
        double titre=aval.X;
       
        Corps lecorps=(rg.corps.Corps)aval.lecorps;
        lecorps.CalcPropCorps (aval.T-0.1, aval.P, 0);
        Vector vProp=lecorps.getSubstProperties();
        Double f=(Double)vProp.elementAt(5);
        double hl=f.doubleValue();  
        f=(Double)vProp.elementAt(6);
        double sl=f.doubleValue();
        
        amont.getProperties();
        double Samont=amont.S;
        
        double L0=(aval.H-hl)/aval.X;
        double Xis=(Samont-sl)/L0*aval.T;
        double DHis=amont.H-hl-L0*Xis;
        double x_final=(0.5-eta_is_sec+(amont.H-hl)/DHis)/(0.5+L0/DHis);
        double eta_is=eta_is_sec-(1-x_final)/2.;
        return eta_is;
    }

	public void readCompParameters(String ligne_data){
	    String value="";
	    value=Util.extr_value(ligne_data, "mCpBoilerSteam");
		if(!(value==null)){
		    mCpBoilerSteam=Util.lit_d(value);
	    }
	    value=Util.extr_value(ligne_data, "mCpRefrigCond");
		if(!(value==null)){
		    mCpRefrigCond=Util.lit_d(value);
	    }
	    value=Util.extr_value(ligne_data, "Kh");
		if(!(value==null)){
		    Kh=Util.lit_d(value);
	        Kh_value.setText(Util.aff_d(Kh,4));
	    }
	    value=Util.extr_value(ligne_data, "UAboiler");
		if(!(value==null)){
		    UAboiler=Util.lit_d(value);
	        UAboiler_value.setText(Util.aff_d(UAboiler,4));
	    }
	    value=Util.extr_value(ligne_data, "UAcond");
		if(!(value==null)){
		    UAcond=Util.lit_d(value);
	        UAcond_value.setText(Util.aff_d(UAcond,4));
	    }
	    value=Util.extr_value(ligne_data, "mCpBoilerTransfFluid");
		if(!(value==null)){
		    mCpBoilerTransfFluid=Util.lit_d(value);
	        AcalculatedBoiler_value.setText(Util.aff_d(mCpBoilerTransfFluid,4));
	    }
	    value=Util.extr_value(ligne_data, "mCpCalopCond");
		if(!(value==null)){
		    mCpCalopCond=Util.lit_d(value);
	        AcalculatedCond_value.setText(Util.aff_d(mCpCalopCond,4));
	    }
	    value=Util.extr_value(ligne_data, "DeltaHboiler");
		if(!(value==null)){
		    DeltaHboiler=Util.lit_d(value);
	        DeltaHboiler_value.setText(Util.aff_d(DeltaHboiler,4));
	    }
	    value=Util.extr_value(ligne_data, "DeltaHcond");
		if(!(value==null)){
		    DeltaHcond=Util.lit_d(value);
	        DeltaHcond_value.setText(Util.aff_d(DeltaHcond,4));
	    }
	    value=Util.extr_value(ligne_data, "tauTurb");
		if(!(value==null)){
		    tauTurb=Util.lit_d(value);
	        tauCompr_value.setText(Util.aff_d(tauTurb,4));
	    }
	    value=Util.extr_value(ligne_data, "AdesignBoiler");
		if(!(value==null)){
		    AdesignBoiler=Util.lit_d(value);
	        AdesignBoiler_value.setText(Util.aff_d(AdesignBoiler,4));
	    }
	    value=Util.extr_value(ligne_data, "AdesignCond");
		if(!(value==null)){
		    AdesignCond=Util.lit_d(value);
	        AdesignCond_value.setText(Util.aff_d(AdesignCond,4));
	    }
		

  	    value=Util.extr_value(ligne_data, "nutCorrName");
		if(!(value==null)){
		    if(technoBoiler!=null){
		    	technoBoiler.nutCorrelationName=value;
		    	technoBoiler.setNutCorrel(value);
		    }
	    }
	    value=Util.extr_value(ligne_data, "pdcCorrName");
		if(!(value==null)){
		    if(technoBoiler!=null){
		    	technoBoiler.pdcCorrelationName=value;
		    	technoBoiler.setPdcCorrel(value);
		    }
	    }
	    value=Util.extr_value(ligne_data, "p_dbExp=");
		if(!(value==null)){
		    if(technoBoiler!=null){
		    	technoBoiler.A_value.setText(value);
		    }
	    }	
		
		
	    value=Util.extr_value3(ligne_data, "technoBoiler");
		if(!(value==null)){
		    boilerSettings=value;
		    if(technoBoiler!=null)technoBoiler.readCaract(value);
	    }
	    value=Util.extr_value3(ligne_data, "technoCond");
		if(!(value==null)){
		    condSettings=value;
		    if(technoCond!=null)technoCond.readCaract(value);
	    }
	}
	
    public String saveCompParameters(){
	    String h="mCpBoilerSteam="+Util.aff_d(mCpBoilerSteam)+tab  
	    +"mCpRefrigCond="+Util.aff_d(mCpRefrigCond)+tab
	    +"Kh="+Util.aff_d(Kh)+tab
	    +"UAboiler="+Util.aff_d(UAboiler)+tab
	    +"UAcond="+Util.aff_d(UAcond)+tab
	    +"mCpBoilerTransfFluid="+Util.aff_d(mCpBoilerTransfFluid)+tab
	    +"mCpCalopCond="+Util.aff_d(mCpCalopCond)+tab
	    +"DeltaHboiler="+Util.aff_d(DeltaHboiler)+tab
	    +"DeltaHcond="+Util.aff_d(DeltaHcond)+tab
	    +"tauTurb="+Util.aff_d(tauTurb)+tab
	    +"AdesignBoiler="+AdesignBoiler_value.getText()+tab
	    +"AcalculatedBoiler="+AcalculatedBoiler_value.getText()+tab
	    +"AdesignCond="+AdesignCond_value.getText()+tab
	    +"AcalculatedCond="+AcalculatedCond_value.getText()+tab
		+"deltaPsecond="+technoBoiler.techf.dP_value.getText()+tab
	    +"deltaPsingSecond="+technoBoiler.techf.dP_Sing_value.getText()+tab
	    +"deltaPprim="+technoBoiler.techc.dP_value.getText()+tab
	    +"deltaPsingPrim="+technoBoiler.techc.dP_Sing_value.getText()+tab
	    +"nutCorrName="+technoBoiler.nutCorrelationName+tab
	    +"pdcCorrName="+technoBoiler.pdcCorrelationName+tab
	    +"p_dbExp="+technoBoiler.A_value.getText()+tab
	    
	    +"#technoBoiler="+technoBoiler.saveCaract()+"#"+tab
	    +"#technoCond="+technoCond.saveCaract()+"#"+tab
	    ;
        return h;
    }
 	
    

}